/* 
   "Epsilon"
   LPC2378 Demo by Martin Thomas, Kaiserslautern, Germany
   http://www.siwawi.arubi.uni-kl.de/avr_projects/arm_projects

   Target:   LPC2378
   Board:    Olimex LPC-2378-STK
   Compiler: GNU arm-elf or arm-eabi toolchain 
             (tested with WinARM 5/07-beta)
   
   Partly based on drivers from the NXP LPC23xx & 24xx 
   example-collection available from www.nxp.com.
*/

#include <LPC23xx.h>
#include <irq.h>
#include <target.h>

#include <swi.h>

volatile int r;
void T0isr(void);
void T0isr()
{
	r=(r+1)&1;
   if (r==1)
    FIO1SET = 0x00200000;                      /* Turn off LED */
   else
    FIO1CLR = 0x00200000;                      /* Turn on LED */

   T0IR |= 0x00000001;         //Match 0 olustu flagini silelim
   VICVectAddr = 0x00000000;         //Dummy write to signal end of interrupt
}

int main (void)
{
	init_VIC();
	install_irq(TIMER0_INT, T0isr, LOWEST_PRIORITY);

	FIO1DIR = 0x00200000;            // P0.21  Output tanimlandi

	T0PR    = 0x0000001E;
	T0TCR    = 0x00000002;
	T0MCR    = 0x00000003;         //Timer = T0MR0 olunca timeri reset

	//72MHz not 60 in this sample
	// 60E6/2048 = 29Khz lik tasma peryodumuz olacak

	//T0MR0   = 0x00000800;         //Timer0 icin tasma degerimiz (Sample time sayacimiz)
	T0MR0   = 0x80000;
	T0TCR   = 0x00000001;         //Timer0'i baslat

	/* mt: enable IRQ-Exceptions on core-level thru SWI-call */
	IntEnable();
	for (;;) {
	}

	return 0;
}
